#! /usr/bin/env python3

import sys
import copy
import random

def load_file(fname):
    digits = "123456"
    field = []
    with open(fname) as f:
        rem = int(f.readline())
        for _ in range(8):
            field.append([int(c) for c in next(f) if c in digits])

    return rem, field

RIGHT = "right"
DOWN = "down"

UP = "up"
LEFT = "left"

def remove_conns(field, fillup_random = False):
    pts = 0
    torems = [[False] * len(r) for r in field]
    # TODO: Recurse properly!!!
    for r, row in enumerate(field):
        for s, v in enumerate(row):
            if v is None: # Removed stone, ignore
                continue
            try:
                flg = 0
                for rv in range(r + 1, r + 3):
                    if field[rv][s] != v:
                        break
                    else:
                        flg += 1
                if flg == 2:
                    #print("Conn at %d %d %s" % (r, s, "row"))
                    for rv in range(r, r + 3):
                        torems[rv][s] = True
                    pts += 3
            except IndexError:
                pass
            try:
                flg = 0
                for sv in range(s + 1, s + 3):
                    if field[r][sv] != v:
                        break
                    else:
                        flg += 1
                if flg == 2:
                    #print("Conn at %d %d %s" % (r, s, "column"))
                    for sv in range(s, s + 3):
                        torems[r][sv] = True
                    pts += 3
            except IndexError:
                pass
    # Remove marked stones
    for r, row in enumerate(torems):
        for s, v in enumerate(row):
            if v:
                # Shift everything above down by one and fill the top with None
                for rv in range(r, 0, -1):
                    field[rv][s] = field[rv - 1][s]
                field[0][s] = random.randint(1, 6) if fillup_random else None
    if pts:
        # Recurse until there is nothing left
        # The time is going to run out before the stack anyway, so whatever...
        return pts + remove_conns(field)
    return pts

def motion_points(field, r, c, dr, fillup_random = False):
    # Create modified field and process
    nf = copy.deepcopy(field)
    v = nf[r][c]
    if dr == RIGHT:
        nf[r][c] = nf[r][c + 1]
        nf[r][c + 1] = v
    elif dr == DOWN:
        nf[r][c] = nf[r + 1][c]
        nf[r + 1][c] = v
    elif dr == UP:
        nf[r][c] = nf[r - 1][c]
        nf[r - 1][c] = v
    elif dr == LEFT:
        nf[r][c] = nf[r][c - 1]
        nf[r][c - 1] = v
    else:
        assert False # WTF?
    return remove_conns(nf, fillup_random = fillup_random), nf

def available_motions(field, fillup_random = False):
    flg = False
    for r, row in enumerate(field):
        for s, v in enumerate(row):
            mos = []
            if r < len(field) - 1:
                # Can go down
                mos.append(DOWN)
            if s < len(row) - 1:
                # Can go up
                mos.append(RIGHT)
            for m in mos:
                pts, nxt = motion_points(field, r, s, m, fillup_random = fillup_random)
                if pts > 0:
                    # Python is magic!
                    yield (r, s, m, pts, nxt)

if __name__ == "__main__":
    rem, field = load_file("vstup.txt")
    # Find all valid motions and attempt the best one
    best = 0
    bestm = None
    amos = [list(available_motions(field)) for _ in range(1)]
    for mos in zip(*amos):
        pts = sum(m[3] for m in mos) / len(mos)
        if pts > best:
            bestm = mos[0]
            best = pts

    with open("vystup.txt", "w+") as f:
        f.write("%d %d %d %d\n" % (bestm[1] + 1, bestm[0] + 1,
                                   bestm[1] + 1 + (1 if bestm[2] == RIGHT else 0),
                                   bestm[0] + 1 + (1 if bestm[2] == DOWN else 0)))
