#! /usr/bin/env python3

import sys
import curses
import copy

def load_file(fname):
    digits = "123456"
    field = []
    with open(fname) as f:
        rem = int(f.readline())
        for _ in range(8):
            field.append([int(c) for c in next(f) if c in digits])

    return rem, field

RIGHT = "right"
DOWN = "down"

rem, field = load_file("vstup.txt")

def remove_conns(field):
    pts = 0
    # TODO: Recurse properly!!!
    for r, row in enumerate(field):
        for s, v in enumerate(row):
            try:
                flg = 0
                for rv in range(r + 1, r + 3):
                    if field[rv][s] != v:
                        break
                    else:
                        flg += 1
                if flg == 2:
                    print("Conn at %d %d %s" % (r, s, "row"))
                    pts += 3
            except IndexError:
                pass
            try:
                flg = 0
                for sv in range(s + 1, s + 3):
                    if field[r][sv] != v:
                        break
                    else:
                        flg += 1
                if flg == 2:
                    print("Conn at %d %d %s" % (r, s, "column"))
                    pts += 3
            except IndexError:
                pass

    return pts

def motion_points(r, c, dr):
    nf = copy.deepcopy(field)
    v = nf[r][c]
    if dr == RIGHT:
        nf[r][c] = nf[r][c + 1]
        nf[r][c + 1] = v
    elif dr == DOWN: # DOWN
        nf[r][c] = nf[r][c]
        nf[r + 1][c] = v
    else:
        assert False # WTF?
    return remove_conns(nf)

# Find all valid motions and attempt the best one
best = 0
bestm = None
for r, row in enumerate(field):
    for s, v in enumerate(row):
        mos = []
        if r < len(field) - 1:
            # Can go down
            mos.append(DOWN)
        if s < len(row) - 1:
            # Can go up
            mos.append(RIGHT)
        for m in mos:
            pts = motion_points(r, s, m)
            if bestm is None or pts > best:
                best = pts
                bestm = (r, s, m)

with open("vystup.txt", "w+") as f:
    f.write("%d %d %d %d\n" % (bestm[1] + 1, bestm[0] + 1,
                               bestm[1] + 1 + (1 if bestm[2] == RIGHT else 0),
                               bestm[0] + 1 + (1 if bestm[2] == DOWN else 0),
                               ))
